/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package com.unis.safeStorage.modular.dataKcglKcswDefault.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.unis.common.enums.CommonSortOrderEnum;
import com.unis.common.exception.CommonException;
import com.unis.common.page.CommonPageRequest;
import com.unis.safeStorage.modular.dataKcglKcswDefault.entity.DataKcglKcswDefault;
import com.unis.safeStorage.modular.dataKcglKcswDefault.mapper.DataKcglKcswDefaultMapper;
import com.unis.safeStorage.modular.dataKcglKcswDefault.param.DataKcglKcswDefaultAddParam;
import com.unis.safeStorage.modular.dataKcglKcswDefault.param.DataKcglKcswDefaultEditParam;
import com.unis.safeStorage.modular.dataKcglKcswDefault.param.DataKcglKcswDefaultIdParam;
import com.unis.safeStorage.modular.dataKcglKcswDefault.param.DataKcglKcswDefaultPageParam;
import com.unis.safeStorage.modular.dataKcglKcswDefault.service.DataKcglKcswDefaultService;

import java.util.List;

/**
 * 库存实物表Service接口实现类
 *
 * @author hjc
 * @date  2024/06/03 14:57
 **/
@Service
public class DataKcglKcswDefaultServiceImpl extends ServiceImpl<DataKcglKcswDefaultMapper, DataKcglKcswDefault> implements DataKcglKcswDefaultService {

    @Override
    public Page<DataKcglKcswDefault> page(DataKcglKcswDefaultPageParam dataKcglKcswDefaultPageParam) {
        QueryWrapper<DataKcglKcswDefault> queryWrapper = new QueryWrapper<>();
        if(ObjectUtil.isAllNotEmpty(dataKcglKcswDefaultPageParam.getSortField(), dataKcglKcswDefaultPageParam.getSortOrder())) {
            CommonSortOrderEnum.validate(dataKcglKcswDefaultPageParam.getSortOrder());
            queryWrapper.orderBy(true, dataKcglKcswDefaultPageParam.getSortOrder().equals(CommonSortOrderEnum.ASC.getValue()),
                    StrUtil.toUnderlineCase(dataKcglKcswDefaultPageParam.getSortField()));
        } else {
            queryWrapper.lambda().orderByAsc(DataKcglKcswDefault::getDataid);
        }
        return this.page(CommonPageRequest.defaultPage(), queryWrapper);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(DataKcglKcswDefaultAddParam dataKcglKcswDefaultAddParam) {
        DataKcglKcswDefault dataKcglKcswDefault = BeanUtil.toBean(dataKcglKcswDefaultAddParam, DataKcglKcswDefault.class);
        this.save(dataKcglKcswDefault);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(DataKcglKcswDefaultEditParam dataKcglKcswDefaultEditParam) {
        DataKcglKcswDefault dataKcglKcswDefault = new DataKcglKcswDefault();
        BeanUtil.copyProperties(dataKcglKcswDefaultEditParam, dataKcglKcswDefault);
        this.updateById(dataKcglKcswDefault);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<DataKcglKcswDefaultIdParam> dataKcglKcswDefaultIdParamList) {
        // 执行删除
    }

    @Override
    public DataKcglKcswDefault detail(DataKcglKcswDefaultIdParam dataKcglKcswDefaultIdParam) {

        return this.queryEntity(dataKcglKcswDefaultIdParam.getDataid());
    }

    @Override
    public DataKcglKcswDefault queryEntity(String id) {
        DataKcglKcswDefault dataKcglKcswDefault = this.getById(id);
        if(ObjectUtil.isEmpty(dataKcglKcswDefault)) {
            throw new CommonException("库存实物表不存在，id值为：{}", id);
        }
        return dataKcglKcswDefault;
    }
}
